# CbcTreeVariable Class Reference

`#include <CbcTreeLocal.hpp>`

Inheritance diagram for CbcTreeVariable:
[legend]
Collaboration diagram for CbcTreeVariable:
[legend]

List of all members.

## Public Member Functions
| CbcTreeVariable ()
| CbcTreeVariable (CbcModel *model, const double *solution, int range=10, int typeCuts=0, int maxDiversification=0, int timeLimit=1000000, int nodeLimit=1000000, bool refine=true)
| CbcTreeVariable (const CbcTreeVariable &rhs)
CbcTreeVariable & | operator= (const CbcTreeVariable &rhs)
| = operator
virtual | ~CbcTreeVariable ()
virtual CbcTree * | clone () const
| Clone.
virtual void | generateCpp (FILE *fp)
| Create C++ lines to get to current state.
Heap access and maintenance methods
virtual CbcNode * | top () const
| Return the top node of the heap.
virtual void | push (CbcNode *x)
| Add a node to the heap.
virtual void | pop ()
| Remove the top node from the heap.
Other stuff
int | createCut (const double *solution, OsiRowCut &cut)
| Create cut - return -1 if bad, 0 if okay and 1 if cut is everything.
virtual bool | empty ()
| Test if empty *** note may be overridden.
virtual void | endSearch ()
| We may have got an intelligent tree so give it one more chance.
void | reverseCut (int state, double bias=0.0)
| Other side of last cut branch (if bias==rhs_ will be weakest possible).
void | deleteCut (OsiRowCut &cut)
| Delete last cut branch.
void | passInSolution (const double *solution, double solutionValue)
| Pass in solution (so can be used after heuristic).
int | range () const
void | setRange (int value)
int | typeCuts () const
void | setTypeCuts (int value)
int | maxDiversification () const
void | setMaxDiversification (int value)
int | timeLimit () const
void | setTimeLimit (int value)
int | nodeLimit () const
void | setNodeLimit (int value)
bool | refine () const
void | setRefine (bool yesNo)
## Private Attributes
CbcNode * | localNode_
double * | bestSolution_
double * | savedSolution_
int | saveNumberSolutions_
OsiRowCut | cut_
OsiRowCut | fixedCut_
CbcModel * | model_
double * | originalLower_
double * | originalUpper_
int | range_
int | typeCuts_
int | maxDiversification_
int | diversification_
bool | nextStrong_
double | rhs_
double | savedGap_
double | bestCutoff_
int | timeLimit_
int | startTime_
int | nodeLimit_
int | startNode_
int | searchType_
bool | refine_

## Detailed Description

Definition at line 206 of file CbcTreeLocal.hpp.

## Constructor & Destructor Documentation

CbcTreeVariable::CbcTreeVariable | ( |  | ) |

CbcTreeVariable::CbcTreeVariable | ( | CbcModel * | model,
|  | const double * | solution,
|  | int | range = `10`,
|  | int | typeCuts = `0`,
|  | int | maxDiversification = `0`,
|  | int | timeLimit = `1000000`,
|  | int | nodeLimit = `1000000`,
|  | bool | refine = `true` |
| ) |  |  |

CbcTreeVariable::CbcTreeVariable | ( | const CbcTreeVariable & | rhs | ) |

virtual CbcTreeVariable::~CbcTreeVariable | ( |  | ) | `[virtual]`

## Member Function Documentation

CbcTreeVariable& CbcTreeVariable::operator= | ( | const CbcTreeVariable & | rhs | ) |

= operator

Reimplemented from CbcTree.

virtual CbcTree* CbcTreeVariable::clone | ( |  | ) | const`[virtual]`

Clone.

Reimplemented from CbcTree.

virtual void CbcTreeVariable::generateCpp | ( | FILE * | fp | ) | `[virtual]`

Create C++ lines to get to current state.

Reimplemented from CbcTree.

virtual CbcNode* CbcTreeVariable::top | ( |  | ) | const`[virtual]`

Return the top node of the heap.

Reimplemented from CbcTree.

virtual void CbcTreeVariable::push | ( | CbcNode * | x | ) | `[virtual]`

Add a node to the heap.

Reimplemented from CbcTree.

virtual void CbcTreeVariable::pop | ( |  | ) | `[virtual]`

Remove the top node from the heap.

Reimplemented from CbcTree.

int CbcTreeVariable::createCut | ( | const double * | solution,
|  | OsiRowCut & | cut |
| ) |  |  |

Create cut - return -1 if bad, 0 if okay and 1 if cut is everything.

virtual bool CbcTreeVariable::empty | ( |  | ) | `[virtual]`

Test if empty *** note may be overridden.

Reimplemented from CbcTree.

virtual void CbcTreeVariable::endSearch | ( |  | ) | `[virtual]`

We may have got an intelligent tree so give it one more chance.

Reimplemented from CbcTree.

void CbcTreeVariable::reverseCut | ( | int | state,
|  | double | bias = `0.0` |
| ) |  |  |

Other side of last cut branch (if bias==rhs_ will be weakest possible).

void CbcTreeVariable::deleteCut | ( | OsiRowCut & | cut | ) |

Delete last cut branch.

void CbcTreeVariable::passInSolution | ( | const double * | solution,
|  | double | solutionValue |
| ) |  |  |

Pass in solution (so can be used after heuristic).

int CbcTreeVariable::range | ( |  | ) | const`[inline]`

Definition at line 273 of file CbcTreeLocal.hpp.

void CbcTreeVariable::setRange | ( | int | value | ) | `[inline]`

Definition at line 277 of file CbcTreeLocal.hpp.

int CbcTreeVariable::typeCuts | ( |  | ) | const`[inline]`

Definition at line 281 of file CbcTreeLocal.hpp.

void CbcTreeVariable::setTypeCuts | ( | int | value | ) | `[inline]`

Definition at line 285 of file CbcTreeLocal.hpp.

int CbcTreeVariable::maxDiversification | ( |  | ) | const`[inline]`

Definition at line 289 of file CbcTreeLocal.hpp.

void CbcTreeVariable::setMaxDiversification | ( | int | value | ) | `[inline]`

Definition at line 293 of file CbcTreeLocal.hpp.

int CbcTreeVariable::timeLimit | ( |  | ) | const`[inline]`

Definition at line 297 of file CbcTreeLocal.hpp.

void CbcTreeVariable::setTimeLimit | ( | int | value | ) | `[inline]`

Definition at line 301 of file CbcTreeLocal.hpp.

int CbcTreeVariable::nodeLimit | ( |  | ) | const`[inline]`

Definition at line 305 of file CbcTreeLocal.hpp.

void CbcTreeVariable::setNodeLimit | ( | int | value | ) | `[inline]`

Definition at line 309 of file CbcTreeLocal.hpp.

bool CbcTreeVariable::refine | ( |  | ) | const`[inline]`

Definition at line 313 of file CbcTreeLocal.hpp.

void CbcTreeVariable::setRefine | ( | bool | yesNo | ) | `[inline]`

Definition at line 317 of file CbcTreeLocal.hpp.

## Member Data Documentation

CbcNode* CbcTreeVariable::localNode_`[private]`

Definition at line 324 of file CbcTreeLocal.hpp.

double* CbcTreeVariable::bestSolution_`[private]`

Definition at line 326 of file CbcTreeLocal.hpp.

double* CbcTreeVariable::savedSolution_`[private]`

Definition at line 328 of file CbcTreeLocal.hpp.

int CbcTreeVariable::saveNumberSolutions_`[private]`

Definition at line 330 of file CbcTreeLocal.hpp.

OsiRowCut CbcTreeVariable::cut_`[private]`

Definition at line 332 of file CbcTreeLocal.hpp.

OsiRowCut CbcTreeVariable::fixedCut_`[private]`

Definition at line 334 of file CbcTreeLocal.hpp.

CbcModel* CbcTreeVariable::model_`[private]`

Definition at line 336 of file CbcTreeLocal.hpp.

double* CbcTreeVariable::originalLower_`[private]`

Definition at line 338 of file CbcTreeLocal.hpp.

double* CbcTreeVariable::originalUpper_`[private]`

Definition at line 340 of file CbcTreeLocal.hpp.

int CbcTreeVariable::range_`[private]`

Definition at line 342 of file CbcTreeLocal.hpp.

int CbcTreeVariable::typeCuts_`[private]`

Definition at line 344 of file CbcTreeLocal.hpp.

int CbcTreeVariable::maxDiversification_`[private]`

Definition at line 346 of file CbcTreeLocal.hpp.

int CbcTreeVariable::diversification_`[private]`

Definition at line 348 of file CbcTreeLocal.hpp.

bool CbcTreeVariable::nextStrong_`[private]`

Definition at line 350 of file CbcTreeLocal.hpp.

double CbcTreeVariable::rhs_`[private]`

Definition at line 352 of file CbcTreeLocal.hpp.

double CbcTreeVariable::savedGap_`[private]`

Definition at line 354 of file CbcTreeLocal.hpp.

double CbcTreeVariable::bestCutoff_`[private]`

Definition at line 356 of file CbcTreeLocal.hpp.

int CbcTreeVariable::timeLimit_`[private]`

Definition at line 358 of file CbcTreeLocal.hpp.

int CbcTreeVariable::startTime_`[private]`

Definition at line 360 of file CbcTreeLocal.hpp.

int CbcTreeVariable::nodeLimit_`[private]`

Definition at line 362 of file CbcTreeLocal.hpp.

int CbcTreeVariable::startNode_`[private]`

Definition at line 364 of file CbcTreeLocal.hpp.

int CbcTreeVariable::searchType_`[private]`

Definition at line 366 of file CbcTreeLocal.hpp.

bool CbcTreeVariable::refine_`[private]`

Definition at line 368 of file CbcTreeLocal.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Cbc-2.7.8/Cbc/src/CbcTreeLocal.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines